package thermo;

import java.awt.*;
import javax.swing.*;

/**
 * <p>Title: JThermo</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: www.LancOS.com</p>
 * @author Claudio Lanconelli
 * @version 1.0
 */

public class JThermoGUI extends JComponent
{
/**
	private static Color m_tRed = new Color(255,0,0,150);
	private static Color m_tGreen = new Color(0,255,0,150);
	private static Color m_tBlue = new Color(0,0,255,150);

	private static Font m_biFont = new Font("Monospaced", Font.BOLD | Font.ITALIC, 36);
	private static Font m_pFont = new Font("SanSerif", Font.PLAIN, 12);
	private static Font m_bFont = new Font("Serif", Font.BOLD, 24);

	private static ImageIcon m_flight = new ImageIcon("flight.gif");
**/
	// ascissa della colonnina
	int base_x = 64;
	// ordinata della base della colonnina
	int base_y = 200;
	// valore pi basso raggiungibile dall'ordinata
	// equiv. al livello max della colonnina
	int liv_y_max = 50;
	// soglia dello zero
	int zero = 40;
	// ordinata del livello della colonnina
	int liv_y;
	// ascissa per la stampa della temperatura in cifre
	int x = 95;
	// ascissa per la stampa della temperatura in cifre
	int y = 30;
	// lettura della temperatura
	float Livello = 0;
	int Errore = 0;
	// Stringa che rappresenta la temperatura in cifre
	String in_cifre;
	Font m_font = new Font("SansSerif", Font.BOLD, 16);

	// termoImg  lo sfondo con il disegno del termometro
//	Image m_termoImg = getImage(getCodeBase(), "termo.gif");
	ImageIcon m_termoImg = new ImageIcon(thermo.JThermoGUI.class.getResource("termo.gif"));


	// livelloIMG  una piccola immagine GIF
	// che rappresenta la colonnina di mercurio
	// e ha dimensione di 1 pixel x 15
//	Image m_livelloImg = getImage(getCodeBase(), "livello.gif");
	ImageIcon m_livelloImg = new ImageIcon(thermo.JThermoGUI.class.getResource("livello.gif"));

	static int counter = 0;

	public JThermoGUI()
	{
	}

	public void setLivello(float val)
	{
		if (val < 130 && val > -20)
		{
		    Livello = val;
		    repaint();
		}
	}
	public float getLivello()
	{
		return Livello;
	}

	public void setErrore(int val)
	{
		Errore = val;
	}
	public int getErrore()
	{
		return Errore;
	}

	public void paintComponent(Graphics g)
	{
		super.paintComponent(g);

		counter++;
		System.out.println(counter);

		liv_y = base_y - zero - (int)(Livello * 2);
		in_cifre = Livello + "";

		// Disegna il termometro
		int w = m_termoImg.getIconWidth();
		int h = m_termoImg.getIconHeight();
//		g.drawImage(m_termoImg, 0, 0, this);
		m_termoImg.paintIcon(this, g, 0, 0);

		// Seleziona il font carattere
		g.setFont(m_font);

		if (Errore != 0)
		{
			// Sceglie il colore nero
			g.setColor(Color.black);
			// Disegna l'ombreggiatura del testo
			g.drawString("Errore", x-5 + 1, y + 1);
		    g.drawString("n. " + Errore, x-5 + 1, y+20 + 1);

			// Sceglie il colore bianco
			g.setColor(Color.white);
			// Disegna la temperatura in cifre
			g.drawString("Errore", x-5, y);
		    g.drawString("n. " + Errore, x-5, y+20);
		}
		else
		{
			// Sceglie il colore nero
			g.setColor(Color.black);
			// Disegna l'ombreggiatura del testo
			g.drawString(in_cifre, x + 1, y + 1);

			// Sceglie il colore bianco
			g.setColor(Color.white);
			// Disegna la temperatura in cifre
			g.drawString(in_cifre, x, y);
		}

		/* Disegna la colonnina
		   l'immagine livelloImg viene usata
		   come timbro e va a riempire la colonnina
		   fino al livello indicato da liv_y
		   partendo da base_y
		*/
		for ( int i = base_y; i >=liv_y; i--)
		{
		//	g.drawImage(m_livelloImg, base_x, i, this);
		    m_livelloImg.paintIcon(this, g, base_x, i);
		}
	}
/**
	public void paintComponent(Graphics g)
	{
		super.paintComponent(g);

		// counter
		int c = 0;

		// for use below
		int w = 0;
		int h = 0;
		int d = 0;

		// get damaged region
		Rectangle r = g.getClipBounds();
		int clipx = r.x;
		int clipy = r.y;
		int clipw = r.width;
		int cliph = r.height;

		// fill only damaged region only
		g.setColor(Color.white);
		g.fillRect(clipx,clipy,clipw,cliph);

		// filled yellow circle if bounding region has been damaged
		if (clipx <= 240 && clipy <= 240)
		{
			g.setColor(Color.yellow);
			g.fillOval(0,0,240,240); c++;
		}

		// filled magenta circle if bounding region has been damaged
		if (clipx + clipw >= 160 && clipx <= 400
			&& clipy + cliph >= 160 && clipy <= 400)
		{
			g.setColor(Color.magenta);
			g.fillOval(160,160,240,240); c++;
		}

		w = m_flight.getIconWidth();
		h = m_flight.getIconHeight();
		// paint the icon below blue sqaure if bounding region has been damaged
		if (clipx + clipw >= 280-(w/2) && clipx <= (280+(w/2))
	    	&& clipy + cliph >= 120-(h/2) && clipy <= (120+(h/2)))
		{
			m_flight.paintIcon(this,g,280-(w/2),120-(h/2)); c++;
		}

		// paint the icon below red sqaure if bounding region has been damaged
		if (clipx + clipw >= 120-(w/2) && clipx <= (120+(w/2))
	    	&& clipy + cliph >= 280-(h/2) && clipy <= (280+(h/2)))
		{
			m_flight.paintIcon(this,g,120-(w/2),280-(h/2)); c++;
		}

		// filled transparent red square if bounding region has been damaged
		if (clipx + clipw >= 60 && clipx <= 180
			&& clipy + cliph >= 220 && clipy <= 340)
		{
			g.setColor(m_tRed);
			g.fillRect(60,220,120,120); c++;
		}

		// filled transparent green circle if bounding region has been damaged
		if (clipx + clipw > 140 && clipx < 260
			&& clipy + cliph > 140 && clipy < 260)
		{
			g.setColor(m_tGreen);
			g.fillOval(140,140,120,120); c++;
		}

		// filled transparent blue square if bounding region has been damaged
		if (clipx + clipw > 220 && clipx < 380
			&& clipy + cliph > 60 && clipy < 180)
		{
			g.setColor(m_tBlue);
			g.fillRect(220,60,120,120); c++;
		}

		g.setColor(Color.black);

		g.setFont(m_biFont);
		FontMetrics fm = g.getFontMetrics();
		w = fm.stringWidth("Swing");
		h = fm.getAscent();
		d = fm.getDescent();
		// Bold, Italic, 36-point "Swing" if bounding region has been damaged
		if (clipx + clipw > 120-(w/2) && clipx < (120+(w/2))
		    && clipy + cliph > (120+(h/4))-h && clipy < (120+(h/4))+d)
		{
			g.drawString("Swing",120-(w/2),120+(h/4)); c++;
		}

		g.setFont(m_pFont);
		fm = g.getFontMetrics();
		w = fm.stringWidth("is");
		h = fm.getAscent();
		d = fm.getDescent();
		// Plain, 12-point "is" if bounding region has been damaged
		if (clipx + clipw > 200-(w/2) && clipx < (200+(w/2))
	    	&& clipy + cliph > (200+(h/4))-h && clipy < (200+(h/4))+d)
		{
			g.drawString("is",200-(w/2),200+(h/4)); c++;
		}

		g.setFont(m_bFont);
		fm = g.getFontMetrics();
		w = fm.stringWidth("powerful!!");
		h = fm.getAscent();
		d = fm.getDescent();

		// Bold 24-point "powerful!!" if bounding region has been damaged
		if (clipx + clipw > 280-(w/2) && clipx < (280+(w/2))
			&& clipy + cliph > (280+(h/4))-h && clipy < (280+(h/4))+d)
		{
			g.drawString("powerful!!",280-(w/2),280+(h/4)); c++;
		}

		System.out.println("# items repainted = " + c + "/10");
	}
**/

	// Some layout managers need this information
	public Dimension getPreferredSize()
	{
	//	return new Dimension(400,400);
		return new Dimension(143,284);
	}

	// Some layout managers need this information
	public Dimension getMinimumSize()
	{
	    return getPreferredSize();
	}
}